'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _os = require('os');

var _os2 = _interopRequireDefault(_os);

var _fs = require('mz/fs');

var _fs2 = _interopRequireDefault(_fs);

var _express = require('express');

var _express2 = _interopRequireDefault(_express);

var _bodyParser = require('body-parser');

var _bodyParser2 = _interopRequireDefault(_bodyParser);

var _open = require('open');

var _open2 = _interopRequireDefault(_open);

var _config = require('./config');

var _config2 = _interopRequireDefault(_config);

var _repository_collection = require('./repository_collection');

var _repository_collection2 = _interopRequireDefault(_repository_collection);

var _utility = require('./utility');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

var router = _express2.default.Router();
exports.default = router;


router.use(_bodyParser2.default.json());

router.get('/repositories', function () {
  var _ref = _asyncToGenerator(regeneratorRuntime.mark(function _callee(req, res) {
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return Promise.all(_repository_collection2.default.map(function (r) {
              return r.ready;
            }));

          case 2:
            res.send(_repository_collection2.default.map(function (r) {
              return r.toJSON();
            }));

          case 3:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, undefined);
  }));

  return function (_x, _x2) {
    return _ref.apply(this, arguments);
  };
}());

router.get('/config', function (req, res) {
  (0, _utility.isLocalhost)(req) ? res.json(_config2.default) : res.json(_extends({}, _config2.default, { token: null }));
});

// All following requests must be from localhost
var message = 'For security, the Codex Development Server only accepts requests from localhost.';

router.use(function (req, res, next) {
  (0, _utility.isLocalhost)(req) ? next() : res.status(403).send(message);
});

router.post('/config', function (req, res) {
  (0, _config.writeConfig)(req.body);
  res.json(_config2.default);
  (0, _repository_collection.updateRepositories)();
});

router.post('/path', function () {
  var _ref2 = _asyncToGenerator(regeneratorRuntime.mark(function _callee2(req, res) {
    var stats;
    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _context2.prev = 0;
            _context2.next = 3;
            return _fs2.default.stat(req.body.path + '/.git');

          case 3:
            stats = _context2.sent;

            res.send(stats.isDirectory() ? 'true' : 'false');
            _context2.next = 10;
            break;

          case 7:
            _context2.prev = 7;
            _context2.t0 = _context2['catch'](0);

            res.send('false');

          case 10:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, undefined, [[0, 7]]);
  }));

  return function (_x3, _x4) {
    return _ref2.apply(this, arguments);
  };
}());

router.post('/open', function (req, res) {
  (0, _open2.default)(req.query.path);
  res.send('"ok"');
});