'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.listening = exports.port = exports.default = undefined;

require('regenerator-runtime/runtime');

var _portfinder = require('portfinder');

var _portfinder2 = _interopRequireDefault(_portfinder);

var _express = require('express');

var _express2 = _interopRequireDefault(_express);

var _http = require('http');

var _http2 = _interopRequireDefault(_http);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _open = require('open');

var _open2 = _interopRequireDefault(_open);

var _log = require('./log');

var log = _interopRequireWildcard(_log);

var _api = require('./api');

var _api2 = _interopRequireDefault(_api);

var _config = require('./config');

var _config2 = _interopRequireDefault(_config);

var _repository_collection = require('./repository_collection');

var _socket = require('./socket');

var _socket2 = _interopRequireDefault(_socket);

var _routes = require('./routes');

var routes = _interopRequireWildcard(_routes);

var _env = require('./env');

var env = _interopRequireWildcard(_env);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

(0, _repository_collection.updateRepositories)();
(0, _repository_collection.printRepositories)();

process.on('unhandledRejection', function (reason) {
  return console.log(reason);
});

var app = (0, _express2.default)();
exports.default = app;

app.set('views', _path2.default.join(__dirname, '../../src/views'));
app.set('view engine', 'pug');

var server = _http2.default.createServer(app);
(0, _socket2.default)(server);

app.use('/api', _api2.default);
app.get('*.(js|css|map|html|svg|ttf|woff|woff2)', routes.sendAsset);
app.get('*', routes.sendHTML);

var port = exports.port = undefined;
var basePort = process.env.CP_PORT * 1 || 8000;
_portfinder2.default.basePort = basePort;

var listening = exports.listening = new Promise(function (resolve) {

  _portfinder2.default.getPort(function (err, foundPort) {
    exports.port = port = foundPort;

    server.listen(port, function () {
      if (port !== basePort) log.magenta('Port ' + basePort + ' is not available, listening on ' + port);else log.magenta('Listening on port ' + port);
    });

    // this when run from command line as NPM package
    if (process.env.CP_OPEN === 'true') (0, _open2.default)('http://localhost:' + port + '/');

    resolve(port);
  });
});