'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _fs = require('mz/fs');

var _fs2 = _interopRequireDefault(_fs);

var _log = require('./log');

var log = _interopRequireWildcard(_log);

var _less = require('less');

var _less2 = _interopRequireDefault(_less);

var _postcss = require('postcss');

var _postcss2 = _interopRequireDefault(_postcss);

var _autoprefixer = require('autoprefixer');

var _autoprefixer2 = _interopRequireDefault(_autoprefixer);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

exports.default = function () {
  var _ref = _asyncToGenerator(regeneratorRuntime.mark(function _callee(args) {
    var assetPath, filename, directory, repositoryName, fullPath, source, _postcss$process, css, _source, out, deps;

    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            assetPath = args.assetPath, filename = args.filename, directory = args.directory, repositoryName = args.repositoryName;
            fullPath = _path2.default.join(directory, filename);

            if (!/\.css$/.test(filename)) {
              _context.next = 17;
              break;
            }

            _context.prev = 3;
            _context.next = 6;
            return _fs2.default.readFile(fullPath, 'utf8');

          case 6:
            source = _context.sent;
            _postcss$process = (0, _postcss2.default)([_autoprefixer2.default]).process(source), css = _postcss$process.css;
            return _context.abrupt('return', { code: css });

          case 11:
            _context.prev = 11;
            _context.t0 = _context['catch'](3);

            log.error(_context.t0);

            throw {
              filename: filename,
              type: 'CSS',
              message: _context.t0.reason,
              line: _context.t0.line,
              column: _context.t0.column
            };

          case 15:
            _context.next = 36;
            break;

          case 17:
            if (!/\.less$/.test(filename)) {
              _context.next = 36;
              break;
            }

            _context.prev = 18;
            _context.next = 21;
            return _fs2.default.readFile(fullPath, 'utf8');

          case 21:
            _source = _context.sent;
            _context.next = 24;
            return _less2.default.render(_source, {
              filename: fullPath,
              strictMath: true,
              strictUnits: true,
              sourceMap: {
                outputSourceFiles: true,
                sourceMapFileInline: true
              }
            });

          case 24:
            out = _context.sent;
            deps = out.imports.map(function (i) {
              return i.slice(directory.length + 1);
            });
            _context.next = 28;
            return (0, _postcss2.default)([_autoprefixer2.default]).process(out.css, { map: true });

          case 28:
            out = _context.sent;
            return _context.abrupt('return', { deps: deps, code: out.css });

          case 32:
            _context.prev = 32;
            _context.t1 = _context['catch'](18);

            log.error(_context.t1);

            throw {
              filename: filename,
              type: 'CSS',
              message: _context.t1.message,
              line: _context.t1.line,
              column: _context.t1.index,
              extract: _context.t1.extract ? _context.t1.extract.join('\n') : ''
            };

          case 36:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this, [[3, 11], [18, 32]]);
  }));

  function processCSS(_x) {
    return _ref.apply(this, arguments);
  }

  return processCSS;
}();