'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.transpileModule = exports.transpileScript = undefined;

var transpileScript = exports.transpileScript = function () {
  var _ref = _asyncToGenerator(regeneratorRuntime.mark(function _callee(args) {
    var filename, directory, assetPath, fullPath, code, env, result, message;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            filename = args.filename, directory = args.directory, assetPath = args.assetPath;
            fullPath = _path2.default.join(directory, filename);
            _context.next = 4;
            return _fs2.default.readFile(fullPath, 'utf-8');

          case 4:
            code = _context.sent;
            env = process.env.NODE_ENV;

            process.env.NODE_ENV = 'development';

            _context.prev = 7;
            result = babel.transform(code, {
              moduleId: assetPath,
              sourceMaps: 'inline',
              sourceFileName: fullPath,
              presets: [[require.resolve('babel-preset-env'), { modules: false }]],
              plugins: [require.resolve('babel-plugin-transform-custom-element-classes'), require.resolve('babel-plugin-transform-react-jsx'), require.resolve('babel-plugin-syntax-dynamic-import'), require.resolve('babel-plugin-transform-new-target'), require.resolve('babel-plugin-transform-node-env-inline')]
            });


            process.env.NODE_ENV = env;

            return _context.abrupt('return', result.code);

          case 13:
            _context.prev = 13;
            _context.t0 = _context['catch'](7);


            process.env.NODE_ENV = env;

            message = 'Error in file "' + fullPath + '":\n  ' + _context.t0.message;

            log.error(message);
            if (_context.t0.codeFrame) log.error(_context.t0.codeFrame);

            throw {
              type: 'JavaScript',
              filename: filename,
              message: _context.t0.message,
              line: _context.t0.loc && _context.t0.loc.line,
              column: _context.t0.loc && _context.t0.loc.column,
              // removes ANSI color escapes
              extract: _context.t0.codeFrame && _context.t0.codeFrame.replace(/[\u001b\u009b][[()#;?]*(?:[0-9]{1,4}(?:;[0-9]{0,4})*)?[0-9A-ORZcf-nqry=><]/g, '')
            };

          case 20:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this, [[7, 13]]);
  }));

  return function transpileScript(_x) {
    return _ref.apply(this, arguments);
  };
}();

var transpileModule = exports.transpileModule = function () {
  var _ref2 = _asyncToGenerator(regeneratorRuntime.mark(function _callee2(args) {
    var filename, directory, assetPath, fullPath, code, env, result, message;
    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            filename = args.filename, directory = args.directory, assetPath = args.assetPath;
            fullPath = _path2.default.join(directory, filename);
            _context2.next = 4;
            return _fs2.default.readFile(fullPath, 'utf-8');

          case 4:
            code = _context2.sent;
            env = process.env.NODE_ENV;

            process.env.NODE_ENV = 'development';

            _context2.prev = 7;
            result = babel.transform(code, {
              moduleId: assetPath,
              sourceMaps: 'inline',
              sourceFileName: fullPath,
              presets: [[require.resolve('babel-preset-env'), { modules: false }]],
              plugins: [require.resolve('babel-plugin-transform-custom-element-classes'), require.resolve('babel-plugin-transform-es2015-modules-systemjs'), require.resolve('babel-plugin-transform-react-jsx'), require.resolve('babel-plugin-syntax-dynamic-import'), require.resolve('babel-plugin-transform-new-target'), require.resolve('babel-plugin-transform-node-env-inline')]
            });


            process.env.NODE_ENV = env;

            return _context2.abrupt('return', result.code);

          case 13:
            _context2.prev = 13;
            _context2.t0 = _context2['catch'](7);


            process.env.NODE_ENV = env;

            message = 'Error in file "' + fullPath + '":\n  ' + _context2.t0.message;

            log.error(message);
            if (_context2.t0.codeFrame) log.error(_context2.t0.codeFrame);

            throw {
              type: 'JavaScript',
              filename: filename,
              message: _context2.t0.message,
              line: _context2.t0.loc && _context2.t0.loc.line,
              column: _context2.t0.loc && _context2.t0.loc.column,
              // removes ANSI color escapes
              extract: _context2.t0.codeFrame && _context2.t0.codeFrame.replace(/[\u001b\u009b][[()#;?]*(?:[0-9]{1,4}(?:;[0-9]{0,4})*)?[0-9A-ORZcf-nqry=><]/g, '')
            };

          case 20:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, this, [[7, 13]]);
  }));

  return function transpileModule(_x2) {
    return _ref2.apply(this, arguments);
  };
}();

var _fs = require('mz/fs');

var _fs2 = _interopRequireDefault(_fs);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _log = require('./log');

var log = _interopRequireWildcard(_log);

var _stream = require('stream');

var _babelCore = require('babel-core');

var babel = _interopRequireWildcard(_babelCore);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

var dependencies = {};