'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = start;
exports.broadcast = broadcast;

var _ws = require('ws');

var _ws2 = _interopRequireDefault(_ws);

var _log = require('./log');

var log = _interopRequireWildcard(_log);

var _config = require('./config');

var _config2 = _interopRequireDefault(_config);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ws = void 0;

function start(server) {
  ws = new _ws2.default.Server({ server: server });

  ws.on('connection', function (ws) {
    log.magenta('WebSocket connected: ' + ws._socket.remoteAddress);
  });
}

function broadcast(message) {
  if (!ws) return;
  message = JSON.stringify(message);
  ws.clients.map(function (client) {
    if (client.readyState === _ws2.default.OPEN) client.send(message);
  });
}